/*
 * Copyright (c) 2003-2003
 *	Fraunhofer Institute for Open Communication Systems (FhG Fokus).
 * 	All rights reserved.
 *
 * Author: Hartmut Brandt <harti@freebsd.org>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Begemot: atmsupport/ats_sig/test_sig.h,v 1.14 2004/08/18 12:49:51 brandt Exp $
 */
#include <sys/types.h>
#include <stdint.h>

/*
 * Interface to UNI stack implementation
 */
struct uni_msg;
struct ustack {
	void	(*init)(void);
	void	(*reset)(void);
	void	(*start)(const u_int *, const struct uni_config *,
		    uint32_t, uint32_t, uint32_t);
	void	(*saal_to_uni)(struct uni_msg *);
	void	(*saal_establish_ind)(void);
	void	(*saal_establish_conf)(void);
	void	(*saal_release_ind)(void);
	void	(*work)(void);
	void	(*api_to_uni)(u_int, u_int, struct uni_msg *);
	void	(*getconfig)(struct uni_config *);
};
extern const struct ustack user_stack;
#ifdef HAVE_NETGRAPH_H
extern const struct ustack kernel_stack;
#endif

/* handle data output to SAAL */
void handle_saal_data(struct uni_msg *msg);

/* handle data output to API */
void handle_api_data(u_int sig, u_int cookie, struct uni_msg *msg);

/* handle SAAL-ESTABLISH.request */
void handle_establish_request(void);
