/*
 * Copyright (c) 2001-2003
 *	Fraunhofer Institute for Open Communication Systems (FhG Fokus).
 * 	All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Author: Hartmut Brandt <harti@freebsd.org>
 *
 * $Begemot: atmsupport/test_uni_user/uniu.h,v 1.4 2004/12/20 10:45:06 brandt Exp $
 *
 * Test user space UNI stack.
 */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <errno.h>
#include <string.h>
#include <err.h>
#include <unistd.h>
#include <limits.h>
#include <rpoll.h>

#define index __index
#define err __err
#include <tcl.h>
#undef index
#undef err

#include <netnatm/unimsg.h>
#include <netnatm/msg/unistruct.h>
#include <netnatm/msg/unimsglib.h>
#include <netnatm/saal/sscop.h>
#include <netnatm/saal/sscfu.h>
#include <netnatm/sig/uni.h>
#include <netnatm/sig/unisig.h>

struct stk {
	struct sscop	*sscop;
	struct sscfu	*sscf;
	struct uni	*uni;
	int		atm_fd;
	int		atm_fdh;
	int		user_fd;
	int		user_fdh;
	Tcl_Interp	*interp;
};

void user_output(struct stk *, enum uni_sig, u_int32_t, struct uni_msg *);
void user_tcl_init(struct stk *);

void bug(const char *, ...) __printflike(1, 2) __dead2;

void try_exec(Tcl_Interp *interp, Tcl_DString *);
void try_event(Tcl_Interp *interp, Tcl_DString *);
void set_error(Tcl_Interp *interp, const char *fmt, ...);

extern int errinfo;
extern int doprompt;
